/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : JSSPCrossoverImpl.cc                                      */
/*************************************************************************/
/*************************************************************************/

#include "JSSPCrossover.h"
#include "JSSPChromosomes.h"
#include <Chromosomes.h>
#include <ChromosomesBag.h>
#include <stdlib.h>

JSSPCrossover::JSSPCrossover() { debug = 0; }

void JSSPCrossover::debugOn() { debug = 1; }

void JSSPCrossover::debugOff() { debug = 0; }

JSSPCrossover::~JSSPCrossover()
{  cout << " de allocate JSSPCrossover " << endl;
}

ChromosomesBag JSSPCrossover::apply(Chromosomes* par1, Chromosomes * par2)
{   JSSPChromosomes *parent1 = (JSSPChromosomes *) par1;
    JSSPChromosomes *parent2 = (JSSPChromosomes *) par2;
    int NumFac = (*parent1).getMaxFacilityNumber();
    int CrossPoint = (int) (rand() % NumFac);
    int i;
    char ch[10];

    JSSPChromosomes *offspring1 = new JSSPChromosomes;
    JSSPChromosomes *offspring2 = new JSSPChromosomes;

    (*offspring1).setOnlyMyProblem(*(*parent1).getMyProblem());
    (*offspring2).setOnlyMyProblem(*(*parent1).getMyProblem());

    if(debug) cout << " I am in JSSPCrossover::apply() " << endl;

    for(i=0;i<CrossPoint;i++)
    { 
      if((*parent1).getFacilityScheduleIndex(i)!=NULL)
      {
	if(debug) 
	   cout << " Facility is " << (*((*parent1).getFacilityScheduleIndex(i))) << endl;
	(*offspring1).addFacilitySchedule(*(*parent1).getFacilityScheduleIndex(i));
	if(debug) cout << " added to offspring1 " << endl;
      }
      if((*parent2).getFacilityScheduleIndex(i)!=NULL)
        (*offspring2).addFacilitySchedule(*(*parent2).getFacilityScheduleIndex(i));
    }// end of for 

    if(debug) cout << " After first loop " << endl;

    for(;i<NumFac;i++)
    {  
      if((*parent2).getFacilityScheduleIndex(i)!=NULL)
        (*offspring1).addFacilitySchedule(*(*parent2).getFacilityScheduleIndex(i));
      if((*parent1).getFacilityScheduleIndex(i)!=NULL)
        (*offspring2).addFacilitySchedule(*(*parent1).getFacilityScheduleIndex(i));

      if(debug) cout << " Second loop i : " << i << endl;
    }// end of for

    // If they are not feasible, then restore them.

    if(debug) cout << " After Second loop " << endl;
    if(!(*offspring1).isFeasible()) (*offspring1).restore();
    if(!(*offspring2).isFeasible()) (*offspring2).restore();

    /*
    cout << " Before local enhancement " << *((*offspring1).getFitnessValue());
    (*offspring1).LocalImprove();
    cout << " After local enhancement " << *((*offspring1).getFitnessValue()) << endl;
    cout << " Before local enhancement " << *((*offspring2).getFitnessValue());
    (*offspring2).LocalImprove();
    cout << " After local enhancement " << *((*offspring2).getFitnessValue()) << endl;
    */

    if(debug) cout << " Before ChromosomesBag  " << endl;
    ChromosomesBag ret(2);
    ret.addChromosomes(offspring1);
    ret.addChromosomes(offspring2);

    if(debug) cout << " I am out of JSSPCrossover::apply() " << endl;

    /*cout << "parent 1 " << (*(JSSPSolution *)parent1) << endl;
    cout << "parent 2 " << (*(JSSPSolution *)parent2) << endl;
    cout << "offspring 1 " << (*(JSSPSolution *)offspring1) << endl;
    cout << "offspring 2 " << (*(JSSPSolution *)offspring2) << endl;
    */

    return ret;

}// end of apply()

